VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5850
   ClientLeft      =   225
   ClientTop       =   570
   ClientWidth     =   10560
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   10560
   StartUpPosition =   3  'Windows Default
   Begin Proyecto1.ucGallery ucGallery1 
      Height          =   5175
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   6975
      _extentx        =   12303
      _extenty        =   9128
      backcolor       =   16053492
      borderradius    =   0
      itemsbackcolor  =   15790320
      itemselbackcolor=   16777215
      itemsborderradius=   15
      itemsminwidth   =   300
      itemsheight     =   100
      grouptitleheight=   0
      font            =   "Form1.frx":0000
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type Items
    Title As String
    Publisher As String
    shortDescription As String
    iconURL As String
    Image As Long
End Type

Dim mItems() As Items
Dim NumPage As Long
Dim ItemsCount As Long
Dim Margin As Long
Dim IconSize As Long

Private Sub CargarItems()
    Dim sURL As String
    Dim oXMLHTTP As Object
    Dim cJson As JsonBag
    Dim I As Long
    
    NumPage = NumPage + 1
    sURL = "https://appsource.microsoft.com/view/tiledata/?ReviewsMyCommentsFilter=true&category=machine-learning&country=US&entityType=App&page=" & NumPage
    

    Set oXMLHTTP = CreateObject("Microsoft.XMLHTTP")

    oXMLHTTP.Open "GET", sURL, False
    oXMLHTTP.send

    If oXMLHTTP.Status <> 200 Then Exit Sub
    Set cJson = New JsonBag
    cJson.JSON = oXMLHTTP.responseText
     For I = 1 To cJson.Item("apps").Item("dataList").Count
       
        With cJson.Item("apps").Item("dataList")(I)
            ReDim Preserve mItems(ItemsCount)
            mItems(ItemsCount).Title = .Item("title")
            mItems(ItemsCount).Publisher = .Item("publisher")
            mItems(ItemsCount).shortDescription = .Item("shortDescription")
            mItems(ItemsCount).iconURL = .Item("iconURL")

            ucGallery1.AddItem CStr(ItemsCount)
           
            ItemsCount = ItemsCount + 1
        End With
    Next
    ucGallery1.Refresh
    Set oXMLHTTP = Nothing
    Set cJson = Nothing
End Sub

Private Sub Form_Load()
    IconSize = 40 * ucGallery1.GetWindowsDPI
    Margin = 5 * ucGallery1.GetWindowsDPI
    
    CargarItems
End Sub

Private Sub Form_Resize()
    ucGallery1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim I As Long
    For I = 0 To ItemsCount - 1
        GdipDisposeImage mItems(I).Image
    Next
End Sub

Private Sub ucGallery1_OnItemPaint(ByVal hdc As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal ItemID As Variant)
    Dim TW As Long, TH As Long

    If mItems(ItemID).Image = 0 Then
        mItems(ItemID).Image = GetImageThumbnail(mItems(ItemID).iconURL, IconSize, False)
    End If
    DrawImage hdc, mItems(ItemID).Image, Left + Margin, Top + Margin, IconSize, IconSize, 0, 0, 0, 0 ', Margin, Margin, Margin, Margin


    ucGallery1.TextColor = vbBlack
    ucGallery1.Font.Name = "Segoe UI Semibold"
    ucGallery1.Font.Size = 11
    TW = Width - IconSize - Margin * 3
    TH = ucGallery1.TextHeight(mItems(ItemID).Title)
    ucGallery1.DrawText hdc, mItems(ItemID).Title, Left + IconSize + Margin * 2, Top + Margin, TW, TH, DT_LEFT Or DT_SINGLELINE Or DT_WORD_ELLIPSIS

    ucGallery1.Font.Name = "Segoe UI"
    ucGallery1.Font.Size = 10
    ucGallery1.Font.Bold = False
    
    ucGallery1.TextColor = &H525252
 
    TW = Width - IconSize - Margin * 3
    ucGallery1.DrawText hdc, mItems(ItemID).Publisher, Left + IconSize + Margin * 2, Top + Margin * 2 + TH, TW, TH, DT_LEFT Or DT_WORDBREAK Or DT_WORD_ELLIPSIS

    TW = Width - Margin * 3
    TH = Height - Margin * 5 - IconSize
    ucGallery1.DrawText hdc, mItems(ItemID).shortDescription, Left + Margin * 2, Top + Margin * 3 + IconSize, TW, TH, DT_LEFT Or DT_WORDBREAK Or DT_WORD_ELLIPSIS
End Sub

Private Sub ucGallery1_ScrollEnd()
    CargarItems
End Sub

