VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00F4F4F4&
   Caption         =   "Form1"
   ClientHeight    =   5850
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   11475
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   11475
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton Option1 
      Height          =   615
      Index           =   2
      Left            =   1560
      Picture         =   "Form1.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   120
      Width           =   615
   End
   Begin VB.OptionButton Option1 
      Height          =   615
      Index           =   1
      Left            =   840
      Picture         =   "Form1.frx":1C96
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.OptionButton Option1 
      Height          =   615
      Index           =   0
      Left            =   120
      Picture         =   "Form1.frx":392C
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   120
      Value           =   -1  'True
      Width           =   615
   End
   Begin Proyecto1.ucGallery ucGallery1 
      Height          =   5175
      Left            =   360
      TabIndex        =   0
      Top             =   1320
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   9128
      BackColor       =   16053492
      BorderRadius    =   0
      ItemsBackColor  =   16777215
      ItemSelBackColor=   16777215
      ItemsBorderRadius=   15
      ItemsMinWidth   =   200
      ItemsHeight     =   300
      OnHotItem       =   4
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00BDBDBD&
      X1              =   0
      X2              =   19520
      Y1              =   980
      Y2              =   980
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim cImages As Collection
Dim cJson As JsonBag
Dim Margin As Long
Dim TextAreaHeight As Long

Private Sub Command1_Click()
   ucGallery1.ViewMode = VM_SLIDER
End Sub

Private Sub Form_Load()
    Dim sURL As String
    Set cImages = New Collection
    Set cJson = New JsonBag
    Dim I As Long
    Dim oXMLHTTP As Object
    
    TextAreaHeight = 120 * ucGallery1.GetWindowsDPI
    Margin = 5 * ucGallery1.GetWindowsDPI
    
    
    sURL = "https://dummyjson.com/products/categories"
    
    Set oXMLHTTP = CreateObject("Microsoft.XMLHTTP")

    oXMLHTTP.Open "GET", sURL, False
    oXMLHTTP.send

    If oXMLHTTP.Status <> 200 Then Exit Sub

    cJson.JSON = oXMLHTTP.responseText
    
    For I = 1 To cJson.Count
        ucGallery1.AddGroup cJson.Item(I), UCase(cJson.Item(I))
    Next
    
    
    
    sURL = "https://dummyjson.com/products"
    
    Set oXMLHTTP = CreateObject("Microsoft.XMLHTTP")

    oXMLHTTP.Open "GET", sURL, False
    oXMLHTTP.send

    If oXMLHTTP.Status <> 200 Then Exit Sub

    cJson.JSON = oXMLHTTP.responseText

    For I = 1 To cJson.Item("products").Count
        ucGallery1.AddItem CStr(I), cJson.Item("products")(I).Item("description"), cJson.Item("products")(I).Item("category"), IIf(I Mod 5 = 0, 2, 1)
    Next

  
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    ucGallery1.Move 0, 1000, Me.ScaleWidth, Me.ScaleHeight - 1000
End Sub


Private Sub Form_Unload(Cancel As Integer)
    Dim I As Long
    For I = 1 To cImages.Count
        GdipDisposeImage cImages(I)
    Next
End Sub

Private Sub Option1_Click(Index As Integer)
    ucGallery1.ViewMode = Index
End Sub

Private Sub ucGallery1_OnGroupTitlePaint(ByVal hdc As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal GroupID As Variant, ByVal Title As String, ByVal Description As String)
    ucGallery1.Font.Size = 13
    ucGallery1.TextColor = vbBlack
    
    ucGallery1.DrawText hdc, Title, Left, Top, Width - Margin * 2, Height, DT_VCENTER Or DT_SINGLELINE
    
    Left = Left + ucGallery1.TextWidth(Title) + Margin
    
    
    ucGallery1.Font.Size = 10
    ucGallery1.TextColor = vbWhite
    RoundRectPlus hdc, Left, Top + Height / 2 - ucGallery1.TextHeight(Title) / 2, Margin * 4, ucGallery1.TextHeight(Title), &H77000000, 0, 0, 2, 2, 2, 2
    ucGallery1.DrawText hdc, ucGallery1.GroupItemsCount(GroupID), Left, Top, Margin * 4, Height, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE

End Sub

Private Sub ucGallery1_OnItemPaint(ByVal hdc As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal ItemID As Variant)
    Dim hImage  As Long
    Dim sTitle As String
    Dim Price As Currency
    Dim PriceDiscount As Currency
    Dim discountPercentage As Integer
    Dim sbrand As String
    Dim TW As Long, TH As Long
    Dim Rating As Single
    On Error Resume Next
    
    'Image
    hImage = cImages(CStr(ItemID))
    If hImage = 0 Then
        hImage = GetImageThumbnail(cJson.Item("products")(Val(ItemID)).Item("thumbnail"), 400)
        cImages.Add hImage, ItemID
    End If
    
    If ucGallery1.ViewMode = VM_LIST Then
        MdlFuntions.DrawImage hdc, hImage, Left + 1, Top + 1, TextAreaHeight * 2, Height - 2, Margin * 2.5, 0, 0, Margin * 2.5
    Else
        MdlFuntions.DrawImage hdc, hImage, Left + 1, Top + 1, Width - 2, Height - TextAreaHeight, Margin * 2.5, Margin * 2.5, 0, 0
    End If

    'Title
    ucGallery1.TextColor = vbBlack
    sTitle = cJson.Item("products")(Val(ItemID)).Item("title")
    
    If ucGallery1.ViewMode = VM_LIST Then
        ucGallery1.Font.Size = 15
        TH = ucGallery1.TextHeight(sTitle) + Margin
        ucGallery1.DrawText hdc, sTitle, Left + TextAreaHeight * 2 + Margin * 2, Top + Margin, Width - Margin * 2 - TextAreaHeight * 2, 200, DT_LEFT Or DT_WORDBREAK
    Else
        ucGallery1.Font.Size = 11
        TH = ucGallery1.TextHeight(sTitle) + Margin
        ucGallery1.DrawText hdc, sTitle, Left + Margin, Top + Height - TextAreaHeight + Margin, Width - Margin * 2, TextAreaHeight / 3, DT_CENTER Or DT_WORDBREAK
    End If
    
    'Descrition
    If ucGallery1.ViewMode = VM_LIST Then
        
        ucGallery1.Font.Size = 10
        ucGallery1.DrawText hdc, cJson.Item("products")(Val(ItemID)).Item("description"), Left + TextAreaHeight * 2 + Margin * 2, Top + TH + Margin, Width - Margin * 2 - TextAreaHeight * 2, 200, DT_LEFT Or DT_WORDBREAK
    End If
    
    'New Price
    ucGallery1.Font.Size = 16
    ucGallery1.Font.Bold = True
    ucGallery1.TextColor = vbRed
    Price = CCur(cJson.Item("products")(Val(ItemID)).Item("price"))
    discountPercentage = CInt(cJson.Item("products")(Val(ItemID)).Item("discountPercentage"))
    PriceDiscount = Price - Price * discountPercentage / 100
    
    If ucGallery1.ViewMode = VM_LIST Then
        ucGallery1.DrawText hdc, FormatCurrency(PriceDiscount, , vbTrue), Left + TextAreaHeight * 2 + Margin * 2, Top, Width - Margin * 2 - TextAreaHeight * 2, Height - Margin * 3, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
    
    
    Else
        ucGallery1.DrawText hdc, FormatCurrency(PriceDiscount, , vbTrue), Left + Margin, Top + Height - TextAreaHeight + TextAreaHeight / 3 + Margin, Width - Margin * 2, TextAreaHeight / 3, DT_CENTER Or DT_WORDBREAK
    End If
    
    ucGallery1.Font.Bold = False
    
    'Old Price
    ucGallery1.Font.Size = 10
    ucGallery1.Font.Strikethrough = True
    ucGallery1.TextColor = vbGrayText
    If ucGallery1.ViewMode = VM_LIST Then
        ucGallery1.DrawText hdc, FormatCurrency(Price, , vbTrue), Left + TextAreaHeight * 2 + Margin * 2, Top + TH + Margin * 3, Width - Margin * 2 - TextAreaHeight * 2, Height - Margin * 3, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE

    Else
        ucGallery1.DrawText hdc, FormatCurrency(Price, , vbTrue), Left + Margin, Top + Height - TextAreaHeight + TextAreaHeight * 0.66 + Margin, (Width / 2) - Margin, TextAreaHeight / 3, DT_RIGHT
    End If
    ucGallery1.Font.Strikethrough = False
    
    'Discount Percentage
    If ucGallery1.ViewMode = VM_LIST Then
        RoundRectPlus hdc, Left + (Width / 2) + TextAreaHeight - Margin * 5, Top + Height / 2 + Margin * 2, Margin * 12, Margin * 4, &HFF007300, 0, 0, 4, 4, 4, 4

    Else
        RoundRectPlus hdc, Left + (Width / 2) + Margin, Top + Height - TextAreaHeight + TextAreaHeight * 0.66 + Margin, Margin * 12, Margin * 4, &HFF007300, 0, 0, 4, 4, 4, 4

    End If
    ucGallery1.Font.Size = 10
    ucGallery1.TextColor = vbWhite
    If ucGallery1.ViewMode = VM_LIST Then
        ucGallery1.DrawText hdc, discountPercentage & "% OFF", Left + (Width / 2) + TextAreaHeight - Margin * 5, Top + Height / 2 + Margin * 2, Margin * 12, Margin * 4, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
    Else
        ucGallery1.DrawText hdc, discountPercentage & "% OFF", Left + (Width / 2) + Margin, Top + Height - TextAreaHeight + TextAreaHeight * 0.66 + Margin, Margin * 12, Margin * 4, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
    End If
    ucGallery1.TextColor = vbBlack

    'brand
    ucGallery1.Font.Size = 8
    sbrand = cJson.Item("products")(Val(ItemID)).Item("brand")
    TW = ucGallery1.TextWidth(sbrand) + Margin * 2
    TH = ucGallery1.TextHeight(sbrand) + Margin
    RoundRectPlus hdc, Left + Margin, Top + Margin, TW, TH, &HBB7373FF, 0, 0, 4, 4, 4, 4
    ucGallery1.TextColor = vbWhite
    ucGallery1.DrawText hdc, sbrand, Left + Margin, Top + Margin, TW, TH, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
    
    'rating
    ucGallery1.Font.Size = 8
    Rating = CSng(cJson.Item("products")(Val(ItemID)).Item("rating"))
    TW = ucGallery1.TextWidth(String(5, ChrW2(&HE1CE)))
    TH = ucGallery1.TextHeight("A") + Margin
    ucGallery1.TextColor = vb3DLight
    
    If ucGallery1.ViewMode = VM_LIST Then
        ucGallery1.DrawText hdc, String(5, ChrW2(&HE1CF)), Left + Width - TW - Margin, Top + Margin, TW, TH, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE
        ucGallery1.TextColor = vbYellow
        ucGallery1.DrawText hdc, String(5, ChrW2(&HE1CF)), Left + Width - TW - Margin, Top + Margin, TW * Rating / 5, TH, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE
    Else
        ucGallery1.DrawText hdc, String(5, ChrW2(&HE1CF)), Left + Width - TW - Margin, Top + Height - TextAreaHeight - Margin * 4, TW, TH, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE
        ucGallery1.TextColor = vbYellow
        ucGallery1.DrawText hdc, String(5, ChrW2(&HE1CF)), Left + Width - TW - Margin, Top + Height - TextAreaHeight - Margin * 4, TW * Rating / 5, TH, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE
    
    End If
    
    'or integer
    'DrawText hdc, String(Rating, ChrW2(&HE1CF)), Left + Width - TW - Margin, Top + Height - TextAreaHeight - Margin * 4, TW, TH, DT_LEFT Or DT_VCENTER Or DT_SINGLELINE

End Sub

