VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Multiselect example"
   ClientHeight    =   5850
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   8415
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   8415
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3120
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   2415
   End
   Begin Proyecto1.ucGallery ucGallery1 
      Height          =   5175
      Left            =   0
      TabIndex        =   0
      Top             =   720
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   9128
      BorderRadius    =   0
      ItemSelBackColor=   15724527
      ItemsShadowSize =   0
      ItemsBorderRadius=   15
      ItemsMargin     =   10
      ItemsMinWidth   =   200
      ItemsHeight     =   68
      OnHotItem       =   1
      GroupTitleHeight=   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      MultiSelect     =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
Private Declare Function DestroyIcon Lib "user32.dll" (ByVal HIcon As Long) As Long
Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long
Private Declare Function PathCanonicalize Lib "shlwapi.dll" Alias "PathCanonicalizeA" (ByVal pszBuf As String, ByVal pszPath As String) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal I As Long, ByVal hdcDst As Long, ByVal X As Long, ByVal Y As Long, ByVal fStyle As Long) As Long
Private Declare Function CLSIDFromString Lib "ole32" (ByVal str As Long, id As GUID) As Long
Private Declare Function SHGetImageList Lib "shell32.dll" (ByVal Flag As Long, id As GUID, lResult As Long) As Long
Private Declare Function ImageList_DrawEx Lib "comctl32.dll" (ByVal himl As Long, ByVal I As Long, ByVal hdcDst As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal rgbBk As Long, ByVal rgbFg As Long, ByVal fStyle As Long) As Long

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type SHITEMID
    cb                  As Long
    abID                As Byte
End Type

Private Type ITEMIDLIST
    mkid                As SHITEMID
End Type

Private Type SHFILEINFO
    HIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * 260
    szTypeName As String * 80
End Type

Private Const SHGFI_LARGEICON As Long = &H0
Private Const SHGFI_SMALLICON = &H1
Private Const SHGFI_SYSICONINDEX = &H4000
Private Const SHGFI_USEFILEATTRIBUTES As Long = &H10
Private Const SHGFI_OPENICON As Long = &H2
Private Const SHGFI_DISPLAYNAME As Long = &H200
Private Const SHGFI_ATTRIBUTES As Long = &H800
Private Const SHGFI_TYPENAME As Long = &H400

Private Const SHGFI_ICON As Long = &H100
Private Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10
Private Const FILE_ATTRIBUTE_ARCHIVE As Long = &H20
Private Const ILD_TRANSPARENT As Long = &H1


Public Enum SHIL_FLAG
  SHIL_LARGE = &H0      '   The image size is normally 32x32 pixels. However, if the Use large icons option is selected from the Effects section of the Appearance tab in Display Properties, the image is 48x48 pixels.
  SHIL_SMALL = &H1      '   These images are the Shell standard small icon size of 16x16, but the size can be customized by the user.
  SHIL_EXTRALARGE = &H2 '   These images are the Shell standard extra-large icon size. This is typically 48x48, but the size can be customized by the user.
  SHIL_SYSSMALL = &H3   '   These images are the size specified by GetSystemMetrics called with SM_CXSMICON and GetSystemMetrics called with SM_CYSMICON.
  SHIL_JUMBO = &H4      '   Windows Vista and later. The image is normally 256x256 pixels.
End Enum

Private Const SF_DESKTOP = &H0

Dim m_Path As String
Dim Margin As Long
Dim hImgList As Long
Dim IconSize As Long

Public Function GetSpecialFolder(SpecialFolder As Long) As String
    Dim lRet         As Long
    Dim IDL          As ITEMIDLIST
    Dim sPath        As String * 512
    
    lRet = SHGetSpecialFolderLocation(100, SpecialFolder, IDL)
    
    If lRet = 0 Then
        lRet = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath$)
        GetSpecialFolder = Left$(sPath, InStr(sPath, vbNullChar) - 1)
    End If
End Function

Public Function GetFormatSizeFile(ByVal Bytes As Currency) As String
    If Bytes >= 1024 Then
        If Bytes >= 1073741824 Then
            GetFormatSizeFile = Format((Bytes / 1073741824), "##,###,##0.00") & " GB"
        Else
            If Bytes >= 1048576 Then
                GetFormatSizeFile = Format((Bytes / 1048576), "##,###,##0.00") & " MB"
            Else
                GetFormatSizeFile = Format((Bytes \ 1024), "##,###,##0") & " KB"
            End If
        End If
    Else
        'GetFormatSizeFile = Format(Bytes, "##,###,##0") & " Bytes"
        GetFormatSizeFile = "1 KB"
    End If
End Function


Private Function EnumDir(ByVal sPath As String)
    On Error Resume Next
    
    Dim sDir As String
    Dim Row As Long, Col As Long
    Dim I As Long
    Dim sBuff As String
    Dim lRet As Long
    
    
    If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
    
    sBuff = String(256, 0)
    lRet = PathCanonicalize(sBuff, sPath)
    m_Path = Left$(sBuff, InStr(sBuff, Chr(0)) - 1)
    Text1.Text = m_Path
    
    With ucGallery1
        .Redraw = False
        .Clear
         sDir = Dir$(sPath, vbDirectory Or vbArchive)

         Do While Len(sDir)
             If sDir <> "." Then
                 .AddItem sDir
             End If
             sDir = Dir$()
         Loop
        .Redraw = True
        
    End With
End Function


Private Sub Form_Load()
    Margin = 10 * ucGallery1.GetWindowsDPI

    hImgList = GetSystemImageList(SHIL_EXTRALARGE)
    EnumDir GetSpecialFolder(SF_DESKTOP)
    IconSize = 48 * ucGallery1.GetWindowsDPI + Margin * 2
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    If Me.WindowState = vbMinimized Then Exit Sub
    ucGallery1.Move 0, 600, Me.ScaleWidth, Me.ScaleHeight - 600
    Text1.Move 100, 100, Me.ScaleWidth - 200
End Sub

Private Sub ucGridPlus1_CustomSort(bAscending As Boolean, lSortColumn As Long, Value1 As Variant, Value2 As Variant, bSwap As Boolean)
    If lSortColumn = 3 Then
        If bAscending Then
            If GetValFileSize(Value1) < GetValFileSize(Value2) Then
                bSwap = True
            End If
        Else
            If GetValFileSize(Value1) > GetValFileSize(Value2) Then
                bSwap = True
            End If
        End If
    End If
End Sub

Private Function GetValFileSize(ByVal sValue As String) As Long
    Dim sRet() As String
    If Len(sValue) = 0 Then Exit Function
    sRet = Split(sValue, Space(1))
    Select Case sRet(1)
        Case "KB"
            GetValFileSize = Val(sRet(0)) * 1024
        Case "MB"
            GetValFileSize = Val(sRet(0)) * 1048576
        Case "GB"
            GetValFileSize = Val(sRet(0)) * 1073741824
     End Select
End Function

Private Sub ucGallery1_ItemDblClick(ByVal GroupID As Variant, ByVal ItemID As Variant)

    
    If PathIsDirectory(m_Path & ItemID) Then
        EnumDir m_Path & ItemID
    Else
        ShellExecute Me.hwnd, "OPEN", m_Path & ItemID, vbNullString, vbNullString, vbNormal
    End If
End Sub

Private Sub ucGallery1_OnItemPaint(ByVal hdc As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal ItemID As Variant)
    On Error Resume Next 'For unicode files FileLen/FileDateTime
    Dim tSFI As SHFILEINFO
    Dim FileSize As String
    Dim Flags As Long
    If PathIsDirectory(m_Path & ItemID) Then
        Flags = SHGFI_SYSICONINDEX Or SHGFI_LARGEICON
        If ItemID = ".." Then Flags = Flags Or SHGFI_USEFILEATTRIBUTES
    
        Call SHGetFileInfo(m_Path & ItemID, FILE_ATTRIBUTE_DIRECTORY, tSFI, Len(tSFI), Flags)
    Else
        Call SHGetFileInfo(m_Path & ItemID, ByVal 0&, tSFI, Len(tSFI), SHGFI_SYSICONINDEX Or SHGFI_LARGEICON)
        FileSize = GetFormatSizeFile(FileLen(m_Path & ItemID))
        
    End If
    
    ImageList_Draw hImgList, tSFI.iIcon, hdc, Left + Margin, Top + Margin, ILD_TRANSPARENT
    ucGallery1.Font.Size = 11
    ucGallery1.TextColor = vbBlack
    ucGallery1.DrawText hdc, ItemID, Left + IconSize, Top + Margin, Width - IconSize - Margin, Margin * 2, DT_LEFT Or DT_WORD_ELLIPSIS

 
 
    ucGallery1.Font.Size = 8
    ucGallery1.TextColor = vbGrayText
    If ItemID <> ".." Then
        ucGallery1.DrawText hdc, FileSize, Left + IconSize, Top + Margin * 3, Width - IconSize - Margin, Margin * 2, DT_LEFT Or DT_WORD_ELLIPSIS

        ucGallery1.DrawText hdc, FileDateTime(m_Path & ItemID), Left + IconSize, Top + Margin * 4.5, Width - IconSize - Margin, Margin * 2, DT_LEFT Or DT_WORD_ELLIPSIS

    
    End If
End Sub


Public Function GetSystemImageList(ByVal lFlag As SHIL_FLAG) As Long
    Dim IID_IImageList As GUID
    Dim uSHFI As SHFILEINFO
    
    On Error GoTo Handler
    
    CLSIDFromString StrPtr("{46EB5926-582E-4017-9FDF-E8998DAA0950}"), IID_IImageList
    SHGetImageList lFlag, IID_IImageList, GetSystemImageList
    
    If GetSystemImageList Then Exit Function
    
Handler:
    GetSystemImageList = SHGetFileInfo("C:\", 0, uSHFI, Len(uSHFI), SHGFI_SYSICONINDEX Or lFlag)

End Function





